Bug 63101 - Propose a menu item to generate readable overview of Test Plan
Summary: Propose a menu item to generate readable overview of Test Plan
Status: RESOLVED FIXED
Alias: None
Product: JMeter
Classification: Unclassified
Component: Main (show other bugs)
Version: 5.0
Hardware: All All
: P2 enhancement (vote)
Target Milestone: JMETER_5.1
Assignee: JMeter issues mailing list
URL:
Keywords: FixedInTrunk
Depends on:
Blocks:
 
Reported: 2019-01-22 20:42 UTC by Philippe Mouawad
Modified: 2019-02-07 14:43 UTC (History)
1 user (show)



Attachments
First implementation (alpha) based on XSL (39.25 KB, patch)
2019-01-22 20:42 UTC, Philippe Mouawad
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Philippe Mouawad 2019-01-22 20:42:00 UTC
As per discussion on mailing list:

http://mail-archives.apache.org/mod_mbox/jmeter-dev/201901.mbox/%3CCAH9fUpZEBMpR4oiBL54%2BTk1Hm%3DnSLm2uZas50k5xqKpw8knB%2Bg%40mail.gmail.com%3E

There is a need in JMeter since we're not a DSL based tool, to provide an overview of the test for documentation purpose.
It would also help a lot on issue reporting for example.

Currently, the only available option is to use schematic.sh which is:

- outdated (does not consider HttpSamplerProxy)
- very limited (Display element ClassName)
- not friendly to use, you need to copy the test plan in extras folder to make it work

As the expected overview might depend a lot on what somebody wants to see, what do you think of this as a first step:

- Create in new Tools menu Item (where we would move Curl, Export Transactions for Report, Create Heap/Thread dump) an entry "Export as schematic overview"
- The feature would :
 open A dialog with Option path to enter Exporter

I see at least 2 ways to implement exporter:
        XSL with schematic way:
            + : Not much work
            - : XSL is not very readable nor friendly
            - : JMeter has no contract on XML

    Add an interface, JMeter would discover implementation and propose it:
        We would use the Visitor pattern 
        + : Very flexible
        + : Easier to maintain, we rely on Java Contract
        - : More work for user
    Note we can implement XSL Exporter as first step

    In the long term, maybe we could be proposing an exporter to YAML or JSON
Comment 1 Philippe Mouawad 2019-01-22 20:42:46 UTC
Created attachment 36387 [details]
First implementation (alpha) based on XSL
Comment 2 Philippe Mouawad 2019-02-01 22:52:48 UTC
Author: pmouawad
Date: Fri Feb  1 22:51:17 2019
New Revision: 1852776

URL: http://svn.apache.org/viewvc?rev=1852776&view=rev
Log:
Bug 63101 - Propose a menu item to generate readable overview of Test Plan
Bugzilla Id: 63101

Added:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SchematicView.java   (with props)
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/schematic.xsl   (with props)
Modified:
    jmeter/trunk/build.xml
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/ActionNames.java
    jmeter/trunk/src/core/org/apache/jmeter/resources/messages.properties
    jmeter/trunk/src/core/org/apache/jmeter/resources/messages_fr.properties
    jmeter/trunk/src/core/org/apache/jmeter/util/JMeterUtils.java
    jmeter/trunk/xdocs/changes.xml
    jmeter/trunk/xdocs/usermanual/properties_reference.xml
Comment 3 Philippe Mouawad 2019-02-07 14:43:28 UTC
Author: pmouawad
Date: Thu Feb  7 08:52:28 2019
New Revision: 1853118

URL: http://svn.apache.org/viewvc?rev=1853118&view=rev
Log:
Bug 63101 Propose a menu item to generate readable overview of Test Plan
Bugzilla Id: 63101

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SchematicView.java
    
Author: pmouawad
Date: Thu Feb  7 14:41:40 2019
New Revision: 1853140

URL: http://svn.apache.org/viewvc?rev=1853140&view=rev
Log:
Bug 63101 Propose a menu item to generate readable overview of Test Plan
Drop code committed by error
Bugzilla Id: 63101

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SchematicView.java